package sun.management.snmp.jvmmib;

import javax.management.InstanceAlreadyExistsException;
import javax.management.ObjectName;
import javax.management.MBeanServer;
import com.sun.jmx.snmp.agent.SnmpMibTable;
import java.util.Hashtable;
import com.sun.jmx.snmp.agent.SnmpStandardObjectServer;
import java.io.Serializable;
import com.sun.jmx.snmp.agent.SnmpMib;

public abstract class JVM_MANAGEMENT_MIB extends SnmpMib implements Serializable
{
    static final long serialVersionUID = 6895037919735816732L;
    private boolean isInitialized;
    protected SnmpStandardObjectServer objectserver;
    protected final Hashtable<String, SnmpMibTable> metadatas;
    
    public JVM_MANAGEMENT_MIB() {
        this.isInitialized = false;
        this.metadatas = new Hashtable();
        this.mibName = "JVM_MANAGEMENT_MIB";
    }
    
    public void init() throws IllegalAccessException {
        if (this.isInitialized) {
            return;
        }
        try {
            this.populate(null, null);
        }
        catch (IllegalAccessException ex) {
            throw ex;
        }
        catch (RuntimeException ex2) {
            throw ex2;
        }
        catch (Exception ex3) {
            throw new Error(ex3.getMessage());
        }
        this.isInitialized = true;
        return;
    }
    
    public ObjectName preRegister(MBeanServer server, ObjectName objectName) throws Exception {
        if (this.isInitialized) {
            throw new InstanceAlreadyExistsException();
        }
        this.populate(this.server = server, objectName);
        this.isInitialized = true;
        return objectName;
    }
    
    public void populate(MBeanServer mBeanServer, ObjectName objectName) throws Exception {
        if (this.isInitialized) {
            return;
        }
        if (this.objectserver == null) {
            this.objectserver = new SnmpStandardObjectServer();
        }
        this.initJvmOS(mBeanServer);
        this.initJvmCompilation(mBeanServer);
        this.initJvmRuntime(mBeanServer);
        this.initJvmThreading(mBeanServer);
        this.initJvmMemory(mBeanServer);
        this.initJvmClassLoading(mBeanServer);
        this.isInitialized = true;
        return;
    }
    
    protected void initJvmOS(MBeanServer mBeanServer) throws Exception {
        String groupOid = this.getGroupOid("JvmOS", "1.3.6.1.4.1.42.2.145.3.163.1.1.6");
        ObjectName groupObjectName = null;
        if (mBeanServer != null) {
            groupObjectName = this.getGroupObjectName("JvmOS", groupOid, this.mibName + ":name=sun.management.snmp.jvmmib.JvmOS");
        }
        JvmOSMeta jvmOSMetaNode = this.createJvmOSMetaNode("JvmOS", groupOid, groupObjectName, mBeanServer);
        if (jvmOSMetaNode != null) {
            jvmOSMetaNode.registerTableNodes(this, mBeanServer);
            JvmOSMBean instance = (JvmOSMBean)this.createJvmOSMBean("JvmOS", groupOid, groupObjectName, mBeanServer);
            jvmOSMetaNode.setInstance(instance);
            this.registerGroupNode("JvmOS", groupOid, groupObjectName, jvmOSMetaNode, instance, mBeanServer);
        }
    }
    
    protected JvmOSMeta createJvmOSMetaNode(String s, String s2, ObjectName objectName, MBeanServer mBeanServer) {
        return new JvmOSMeta(this, this.objectserver);
    }
    
    protected abstract Object createJvmOSMBean(String p0, String p1, ObjectName p2, MBeanServer p3);
    
    protected void initJvmCompilation(MBeanServer mBeanServer) throws Exception {
        String groupOid = this.getGroupOid("JvmCompilation", "1.3.6.1.4.1.42.2.145.3.163.1.1.5");
        ObjectName groupObjectName = null;
        if (mBeanServer != null) {
            groupObjectName = this.getGroupObjectName("JvmCompilation", groupOid, this.mibName + ":name=sun.management.snmp.jvmmib.JvmCompilation");
        }
        JvmCompilationMeta jvmCompilationMetaNode = this.createJvmCompilationMetaNode("JvmCompilation", groupOid, groupObjectName, mBeanServer);
        if (jvmCompilationMetaNode != null) {
            jvmCompilationMetaNode.registerTableNodes(this, mBeanServer);
            JvmCompilationMBean instance = (JvmCompilationMBean)this.createJvmCompilationMBean("JvmCompilation", groupOid, groupObjectName, mBeanServer);
            jvmCompilationMetaNode.setInstance(instance);
            this.registerGroupNode("JvmCompilation", groupOid, groupObjectName, jvmCompilationMetaNode, instance, mBeanServer);
        }
    }
    
    protected JvmCompilationMeta createJvmCompilationMetaNode(String s, String s2, ObjectName objectName, MBeanServer mBeanServer) {
        return new JvmCompilationMeta(this, this.objectserver);
    }
    
    protected abstract Object createJvmCompilationMBean(String p0, String p1, ObjectName p2, MBeanServer p3);
    
    protected void initJvmRuntime(MBeanServer mBeanServer) throws Exception {
        String groupOid = this.getGroupOid("JvmRuntime", "1.3.6.1.4.1.42.2.145.3.163.1.1.4");
        ObjectName groupObjectName = null;
        if (mBeanServer != null) {
            groupObjectName = this.getGroupObjectName("JvmRuntime", groupOid, this.mibName + ":name=sun.management.snmp.jvmmib.JvmRuntime");
        }
        JvmRuntimeMeta jvmRuntimeMetaNode = this.createJvmRuntimeMetaNode("JvmRuntime", groupOid, groupObjectName, mBeanServer);
        if (jvmRuntimeMetaNode != null) {
            jvmRuntimeMetaNode.registerTableNodes(this, mBeanServer);
            JvmRuntimeMBean instance = (JvmRuntimeMBean)this.createJvmRuntimeMBean("JvmRuntime", groupOid, groupObjectName, mBeanServer);
            jvmRuntimeMetaNode.setInstance(instance);
            this.registerGroupNode("JvmRuntime", groupOid, groupObjectName, jvmRuntimeMetaNode, instance, mBeanServer);
        }
    }
    
    protected JvmRuntimeMeta createJvmRuntimeMetaNode(String s, String s2, ObjectName objectName, MBeanServer mBeanServer) {
        return new JvmRuntimeMeta(this, this.objectserver);
    }
    
    protected abstract Object createJvmRuntimeMBean(String p0, String p1, ObjectName p2, MBeanServer p3);
    
    protected void initJvmThreading(MBeanServer mBeanServer) throws Exception {
        String groupOid = this.getGroupOid("JvmThreading", "1.3.6.1.4.1.42.2.145.3.163.1.1.3");
        ObjectName groupObjectName = null;
        if (mBeanServer != null) {
            groupObjectName = this.getGroupObjectName("JvmThreading", groupOid, this.mibName + ":name=sun.management.snmp.jvmmib.JvmThreading");
        }
        JvmThreadingMeta jvmThreadingMetaNode = this.createJvmThreadingMetaNode("JvmThreading", groupOid, groupObjectName, mBeanServer);
        if (jvmThreadingMetaNode != null) {
            jvmThreadingMetaNode.registerTableNodes(this, mBeanServer);
            JvmThreadingMBean instance = (JvmThreadingMBean)this.createJvmThreadingMBean("JvmThreading", groupOid, groupObjectName, mBeanServer);
            jvmThreadingMetaNode.setInstance(instance);
            this.registerGroupNode("JvmThreading", groupOid, groupObjectName, jvmThreadingMetaNode, instance, mBeanServer);
        }
    }
    
    protected JvmThreadingMeta createJvmThreadingMetaNode(String s, String s2, ObjectName objectName, MBeanServer mBeanServer) {
        return new JvmThreadingMeta(this, this.objectserver);
    }
    
    protected abstract Object createJvmThreadingMBean(String p0, String p1, ObjectName p2, MBeanServer p3);
    
    protected void initJvmMemory(MBeanServer mBeanServer) throws Exception {
        String groupOid = this.getGroupOid("JvmMemory", "1.3.6.1.4.1.42.2.145.3.163.1.1.2");
        ObjectName groupObjectName = null;
        if (mBeanServer != null) {
            groupObjectName = this.getGroupObjectName("JvmMemory", groupOid, this.mibName + ":name=sun.management.snmp.jvmmib.JvmMemory");
        }
        JvmMemoryMeta jvmMemoryMetaNode = this.createJvmMemoryMetaNode("JvmMemory", groupOid, groupObjectName, mBeanServer);
        if (jvmMemoryMetaNode != null) {
            jvmMemoryMetaNode.registerTableNodes(this, mBeanServer);
            JvmMemoryMBean instance = (JvmMemoryMBean)this.createJvmMemoryMBean("JvmMemory", groupOid, groupObjectName, mBeanServer);
            jvmMemoryMetaNode.setInstance(instance);
            this.registerGroupNode("JvmMemory", groupOid, groupObjectName, jvmMemoryMetaNode, instance, mBeanServer);
        }
    }
    
    protected JvmMemoryMeta createJvmMemoryMetaNode(String s, String s2, ObjectName objectName, MBeanServer mBeanServer) {
        return new JvmMemoryMeta(this, this.objectserver);
    }
    
    protected abstract Object createJvmMemoryMBean(String p0, String p1, ObjectName p2, MBeanServer p3);
    
    protected void initJvmClassLoading(MBeanServer mBeanServer) throws Exception {
        String groupOid = this.getGroupOid("JvmClassLoading", "1.3.6.1.4.1.42.2.145.3.163.1.1.1");
        ObjectName groupObjectName = null;
        if (mBeanServer != null) {
            groupObjectName = this.getGroupObjectName("JvmClassLoading", groupOid, this.mibName + ":name=sun.management.snmp.jvmmib.JvmClassLoading");
        }
        JvmClassLoadingMeta jvmClassLoadingMetaNode = this.createJvmClassLoadingMetaNode("JvmClassLoading", groupOid, groupObjectName, mBeanServer);
        if (jvmClassLoadingMetaNode != null) {
            jvmClassLoadingMetaNode.registerTableNodes(this, mBeanServer);
            JvmClassLoadingMBean instance = (JvmClassLoadingMBean)this.createJvmClassLoadingMBean("JvmClassLoading", groupOid, groupObjectName, mBeanServer);
            jvmClassLoadingMetaNode.setInstance(instance);
            this.registerGroupNode("JvmClassLoading", groupOid, groupObjectName, jvmClassLoadingMetaNode, instance, mBeanServer);
        }
    }
    
    protected JvmClassLoadingMeta createJvmClassLoadingMetaNode(String s, String s2, ObjectName objectName, MBeanServer mBeanServer) {
        return new JvmClassLoadingMeta(this, this.objectserver);
    }
    
    protected abstract Object createJvmClassLoadingMBean(String p0, String p1, ObjectName p2, MBeanServer p3);
    
    public void registerTableMeta(String key, SnmpMibTable value) {
        if (this.metadatas == null) {
            return;
        }
        if (key == null) {
            return;
        }
        this.metadatas.put(key, value);
        return;
    }
    
    public SnmpMibTable getRegisteredTableMeta(String key) {
        if (this.metadatas == null) {
            return null;
        }
        if (key == null) {
            return null;
        }
        return (SnmpMibTable)this.metadatas.get(key);
    }
    
    public SnmpStandardObjectServer getStandardObjectServer() {
        if (this.objectserver == null) {
            this.objectserver = new SnmpStandardObjectServer();
        }
        return this.objectserver;
    }
}
